<script setup lang="ts">
import type { Window } from '@/types/base';
import { Close } from 'slippers-ui/icons';

import { ref, watch, computed } from 'vue';
const props = defineProps({
  lightBackground: {
    type: Boolean,
    required: false,
    default: false,
  },
  visible: {
    type: Boolean,
    required: true,
    default: false,
  },
});

const emit = defineEmits(['close']);

const videoSection = ref<HTMLElement | null>(null);

watch(
  () => props.visible,
  (newValue: boolean) => {
    const body = document.querySelector('body');

    if (newValue) {
      body?.classList.add('noScroll');
      setTimeout(() => {
        (window as Window).__vimeoRefresh?.();
      }, 3000);
    } else {
      body?.classList.remove('noScroll');

      // When modal is closed, pause all videos
      const vimeoIframe = videoSection.value?.querySelector('iframe[src*="vimeo.com"]');
      if (vimeoIframe) {
        vimeoIframe.contentWindow?.postMessage(JSON.stringify({ method: 'pause' }), '*');
      }

      const youtubeIframe = videoSection.value?.querySelector('iframe[src*="youtube.com"]');
      if (youtubeIframe) {
        youtubeIframe.contentWindow?.postMessage(
          JSON.stringify({ event: 'command', func: 'pauseVideo', args: [] }),
          '*',
        );
      }
    }
  },
);

const close = () => {
  emit('close');
};

const backdropClass = computed(() =>
  props.lightBackground ? 'modal__backdrop modal__backdrop--light' : 'modal__backdrop',
);
</script>

<template>
  <div v-show="visible" :class="backdropClass" @click.self="close">
    <div class="modal">
      <header class="modal__header">
        <slot name="header"></slot>
        <button type="button" class="btn btn__close" aria-label="Close" @click="close">
          <SlpIcon :icon="Close" size="lg" class="btn__close-icon" color="black" />
        </button>
      </header>
      <section ref="videoSection" class="modal__body">
        <slot name="body"></slot>
      </section>
      <footer class="modal__footer">
        <slot name="footer"></slot>
      </footer>
    </div>
  </div>
</template>

<style lang="scss" scoped>
.modal {
  background: transparent;
  display: flex;
  flex-direction: column;
  margin-top: $spacing-160;
  @media (max-width: $breakpoint-lg) {
    width: 100%;
  }
  &__backdrop {
    position: fixed;
    top: 0;
    bottom: 0;
    left: 0;
    right: 0;
    background-color: rgba($color-surface-700, 0.85);
    display: flex;
    justify-content: center;
    align-items: flex-start;
    z-index: 1040;
    &--light {
      background-color: #d1d0d3c4;
    }
  }

  &__header {
    position: relative;
    justify-content: space-between;
    background-color: transparent;
  }
  &__header,
  &__footer {
    padding: $spacing-16;
    display: flex;
  }
  &__body {
    position: relative;
    padding: $spacing-8;
  }
}
.btn {
  &__close {
    position: absolute;
    right: -$spacing-8;
    width: 45px;
    height: 45px;
    top: 0;
    border: none;
    border-radius: 50%;
    cursor: pointer;
    @media (min-width: $breakpoint-lg) {
      right: -$spacing-24;
    }

    svg {
      width: 100%;
      height: 100%;
    }
  }
}
</style>
